"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
exports.__esModule = true;
var axios_1 = __importDefault(require("axios"));
// mocks http requests that are used by oauth libraries
var nock = require("nock");
var express = require("express");
var auth_1 = __importDefault(require("../auth"));
describe("@node-api-toolkit/dropbox/auth", function () {
    // we want to close the server after each run whether it's an
    // error or success
    var server;
    afterEach(function (done) {
        server.close(done);
    });
    it("should do an oauth flow", function (done) { return __awaiter(void 0, void 0, void 0, function () {
        var app, onOauthSuccess;
        return __generator(this, function (_a) {
            app = express();
            server = app.listen(8888);
            // if it succeeds we will be redirected here
            app.get("/success", function (req, res) {
                res.json({
                    success: true
                });
            });
            // if it fails we will be redirected here
            app.get("/failure", function (req, res) {
                res.json({
                    success: false
                });
            });
            onOauthSuccess = jest
                .fn()
                .mockImplementation(function (_a) {
                var accessToken = _a.accessToken, refreshToken = _a.refreshToken, profile = _a.profile;
                return new Promise(function (resolve) {
                    var modifiedUser = __assign(__assign({}, profile), { 
                        // attaching metadata
                        metadata: {
                            jwtToken: "123"
                        } });
                    // we usually would do something to link the access token to the user
                    resolve(modifiedUser);
                });
            });
            // adds auth endpoints to the expressApp
            auth_1["default"]({
                appKey: "KEY",
                appSecret: "SECRET",
                onOauthSuccess: onOauthSuccess,
                expressApp: app,
                callbackURL: "http://localhost:8888/auth/dropbox/callback",
                successRedirect: "/success",
                failureRedirect: "/failure"
            });
            // we have start this after the command is run which starts the server
            setTimeout(function () { return __awaiter(void 0, void 0, void 0, function () {
                var oauthRedirectPromise, _a, responseServerPromise, _b;
                return __generator(this, function (_c) {
                    switch (_c.label) {
                        case 0:
                            oauthRedirectPromise = axios_1["default"].get("http://localhost:8888/auth/dropbox");
                            // the endpoint redirects us to dropbox's oauth server (below).
                            // usually it would have a login page where the user clicks "Login"
                            // but here we just mock some text so that we can verify that the
                            // redirect was successful
                            nock("https://www.dropbox.com/oauth2/authorize?response_type=code&redirect_uri=http%3A%2F%2F%2Flocalhost%3A8888%2Fauth%2Fdropbox%2Fcallback&client_id=KEY")
                                .get(/.*/)
                                .reply(200, {
                                status: "I am the oauth server"
                            });
                            // check that we were redirected to the oauth server
                            _a = expect;
                            return [4 /*yield*/, oauthRedirectPromise];
                        case 1:
                            // check that we were redirected to the oauth server
                            _a.apply(void 0, [(_c.sent()).data]).toEqual({
                                status: "I am the oauth server"
                            });
                            responseServerPromise = axios_1["default"].get("http://localhost:8888/auth/dropbox/callback?code=123");
                            // Once the user reaches the callback url, the server will use the
                            // authorization code (code) to get an oauth token. We mock the
                            // response from dropbox's api with the access token and refresh
                            // token
                            nock("https://api.dropbox.com/oauth2/token/")
                                .post(/.*/)
                                .reply(200, {
                                access_token: "I_AM_THE_TOKEN",
                                refresh_token: "REFRESH_TOKEN"
                            });
                            // the callback endpoint then uses the token to reach out and get
                            // the account details which have the account_id and some other
                            // metadata
                            nock("https://api.dropboxapi.com/2/users/get_current_account")
                                .post(/.*/)
                                // from https://www.dropbox.com/developers/documentation/http/documentation#users-get_current_account
                                .reply(200, {
                                account_id: "123",
                                name: {
                                    given_name: "Franz",
                                    surname: "Ferdinand",
                                    familiar_name: "Franz",
                                    display_name: "Franz Ferdinand (Personal)",
                                    abbreviated_name: "FF"
                                },
                                email: "franz@dropbox.com",
                                email_verified: true,
                                disabled: false,
                                locale: "en",
                                referral_link: "https://db.tt/ZITNuhtI",
                                is_paired: true,
                                account_type: {
                                    ".tag": "business"
                                },
                                root_info: {
                                    ".tag": "user",
                                    root_namespace_id: "3235641",
                                    home_namespace_id: "3235641"
                                },
                                country: "US",
                                team: {
                                    id: "dbtid:AAFdgehTzw7WlXhZJsbGCLePe8RvQGYDr-I",
                                    name: "Acme, Inc.",
                                    sharing_policies: {
                                        shared_folder_member_policy: {
                                            ".tag": "team"
                                        },
                                        shared_folder_join_policy: {
                                            ".tag": "from_anyone"
                                        },
                                        shared_link_create_policy: {
                                            ".tag": "team_only"
                                        }
                                    },
                                    office_addin_policy: {
                                        ".tag": "disabled"
                                    }
                                },
                                team_member_id: "dbmid:AAHhy7WsR0x-u4ZCqiDl5Fz5zvuL3kmspwU"
                            });
                            // once the server fetches the user info, it will redirect the user back
                            // to the /success endpoint we created on top. We are verifying the
                            // redirect was successful
                            _b = expect;
                            return [4 /*yield*/, responseServerPromise];
                        case 2:
                            // once the server fetches the user info, it will redirect the user back
                            // to the /success endpoint we created on top. We are verifying the
                            // redirect was successful
                            _b.apply(void 0, [(_c.sent()).data]).toEqual({
                                success: true
                            });
                            // we want to make sure that the function we pass in as a
                            // callback for a successful oauth contains the access token
                            // refresh token, and formatter user
                            expect(onOauthSuccess).toBeCalledWith({
                                accessToken: "I_AM_THE_TOKEN",
                                refreshToken: "REFRESH_TOKEN",
                                user: {
                                    userId: "123",
                                    email: "franz@dropbox.com",
                                    name: {
                                        givenName: "Franz",
                                        familyName: "Ferdinand",
                                        displayName: "Franz Ferdinand (Personal)"
                                    },
                                    profile: expect.anything()
                                }
                            });
                            done();
                            return [2 /*return*/];
                    }
                });
            }); }, 500);
            return [2 /*return*/];
        });
    }); });
});
